: # (forces Bourne shell)
# Copyright 1986, Intel Corporation.
#                           rexec example  (remote tar execution)
# 05/13/86  rhc add PATH for Ar usage
PATH=/bin:/usr/bin	export PATH
PATHTOPROGRAM=$1
shift
PATHTODIR=$1
shift
case $# in
  1)
    nodename=$1 ;;
  2)
    nodename=$1
    log=$2 ;;
  *)
    cat <<-\HERE
       Aaremote.ss: executes programs on a remote node.
       usage: Aaremote.ss <path-to-pgm> <path-to-dir> <remote_node> [<log_file>]
	    <path-to-pgm> is fully qualified path to the program to be executed.
			  (if flags or parms are needed, they should be supplied
			   and the whole string entered as path-to-pgm enclosed
			   in double quotes)
	    <path-to-dir> is the fully qualified path to the directory from 
			  which the tar is to be taken
	    <remote_node> is name of node where the program will
	       be executed.
	    <log_file> is fully qualified path for standard output
	       (including node name).  If <log_file> does not
	       include the node name, it will be relative to
	       <remote_node>.  if <log_file> is omitted, standard
	       output will be returned to your terminal.
	       Note - output is appended to <log_file>.
	HERE
    exit 1
    ;;
esac

netdelm=`net delimiter`
locnode=`net name`
ORIGIFS=$IFS
IFS=$netdelm
set `net name`
locnodename=$1
IFS=$ORIGIFS
case $log in
  "")	# no log specified, send stdout/stderr back to this terminal
    ttydev=`tty`
    outdev=$locnode$ttydev ;;
  *)	# send stdout, stderr to log_file only
    outdev=$log ;;
esac
if [ ! -f $netdelm$nodename/net/self ]
  then
    echo "$nodename Node not accessible." >>$outdev 
    exit 1
fi

remotescript=$netdelm$nodename/tmp/$locnodename$$
cat >$remotescript <<-HERE
	: #	(place commands to be executed on remote node below # # # # #)
	#   	(\$1 is node name, \$2 is path to send stdout/stderr)
	PATH="/bin:/usr/bin:."
	trap "rm -f $remotescript; trap 0; exit" 0 1 2 3 15
	#							***
	cd $PATHTODIR
	$PATHTOPROGRAM  >>\$2 2>&1
	#							***
	# 	(end of commands to be executed on remote node      # # # # #)
HERE
chmod 0700  $remotescript

case $locnodename in
  $nodename)
    $remotescript $nodename $outdev ;;
  *)
    rexec  $remotescript $nodename $outdev -- /dev/null
    while  [ -f $remotescript ]
      do
	sleep 3 #  wait for remote shell script to finish
      done
esac
