: 'Copyright 1986, Intel Corporation.'
:
# "genacf.ss", a shell script to to add/modify user's logins and
#              deauthorizations WITHOUT CHANGING the system's
#              imag.file or menu.file files.

# 05/01/86  gll  Added the -s (silent) option to prevent asking
#                the user questions.

# Process command line parameters.

sopt=
while [ $# -ne 0 ]
do case $1 in -s) sopt=$1
                  ;;

               *) echo "
genacf.ss: unknown parameter(s): $* "
                  exit 1
                  ;;
   esac
   shift
done

if [ "$sopt" = "" ]
then echo "               GENERATE AUTHORIZATION CONTROL FILE 
"
fi

if [ "$sopt" = "" ]
then echo Building authorization file . . .
fi
sort control/login.dat -o control/login.dat
if test -f control/deauth.dat; then 
	sort control/deauth.dat -o control/deauth.dat
fi
if test -f $MDHOME/baf.err; then
	cat $MDHOME/baf.err >>error.tmp
fi

: "Note, this validates against an existing generated menu image file"
$MDHOME/baf control/login.dat control/deauth.dat control/auth.file.tmp \
     control/menu.file 2>>error.tmp
ret2=$?
if test $ret2  != 0; then 
	echo  "ERROR !!!"
fi

if [ "$ret2" = "0" ] ;then 
    if [ "$sopt" = "" ]
    then echo -n "Successful - Make the new file permanent (y or n)? > "
         read resp
    else resp=$sopt
    fi
         case "$resp" in
            y|Y|yes|YES)   echo Reply y to operating system message, if any
                           mv control/auth.file.tmp  control/auth.file
                           rm -f error.tmp
                           echo
                           echo Temporary authorization file made permanent
                           echo
                           currdir=`pwd`
                           if test $currdir = "$MDHOME"; then
                                 echo You will now have to log off and log in again to use
                                 echo the new authorization file!
                           fi
                           ;;

                     -s)   mv control/auth.file.tmp  control/auth.file
                           rm -f error.tmp
                           currdir=`pwd`
                           ;;

            *)             echo
                           echo Old authorization file retained
                           ;;
         esac
else
   echo Unsuccessful execution - fix errors as noted and rerun !
   echo Look in file 'error.tmp' for error messages on this run.
   echo Old authorization file retained.
   echo
   if [ "$sopt" = "" ]
   then echo -n "Do you want to view error.tmp (y or n)? > "
        read resp
   else resp=n
   fi
   case "$resp" in
      y|Y|yes|YES)   status=1
                     ;;
      *)             status=0
                     ;;
   esac
   while test $status = 1
      do
         more error.tmp
         echo
         echo -n "Again (y or n)? > "
         read resp
         case "$resp" in
            y|Y|yes|YES)   status=1
                           ;;
            *)             status=0
                           ;;
         esac
      done
echo
fi
exit 1
