: 'Copyright 1986 Intel Corp.'
# ANtransb.ss, builds final form network node transactions from raw ones
# Assumes is at the proper "*.Batch" directory
# NOTE: AWtransb.ss is a close companion of this routine.  PLEASE
#	CHECK THERE ALSO WHEN CHANGING THIS ROUTINE.
#
#  04/25/86 ugg
#  05/08/86 oer change to reference master node
#  07/02/86 oer add Atsplit, to get away from open file problems w/ awk

MASSYNCH=$MASNODEP`$iDISBIN/Unonode $iDIS`/synch # Master node synch directory
export MASSYNCH

if [ -f $MASSYNCH/debug ] ; then
	set -x
	echo $0
fi

xenixN=/usr/tmp/ANx$$
# traps to ignore 1 and 2 have been set previously
trap "rm -f $xenixN; trap 0; exit" 0 3 15

RAW=./$LOGINID.idisN

# See if there are any transactions to process
if egrep '^#\(' $RAW > /dev/null 2>&1 ; then
	: O.K., some exist to process
else
	exit 0
fi

# split the raw transactions into individual files (T.n)
# We might have restarted from /etc/rc, so remove any existing T.n files
rm -f T.*
$iDISBIN/Atsplit < $RAW

# get list of XENIX nodes
$iDISBIN/Axnodes.ss > $xenixN

# for each XENIX node do required actions
for node in `cat $xenixN`
do
   [ -d $node.work ] || mkdir $node.work
   for trans in `ls T.*`
   do
      (
	 cd $node.work
	 $iDISBIN/ANnodeb.ss $node ../$trans
      )
   done
done

exit 0
